SoFont(3)

NAME
SoFont - The SoFont class is an appearance node for setting fonts.

SYNOPSIS

#include <Inventor/nodes/SoFont.h>

Inherits SoNode.

Inherited by SoFontStyle.

  Public Member Functions
virtual SoType getTypeId (void) const
SoFont (void)
virtual void doAction (SoAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual SbBool affectsState (void) const
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void search (SoSearchAction *action)
virtual void write (SoWriteAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
virtual void notify (SoNotList *l)
SbUniqueId getNodeId (void) const
virtual SoChildList * getChildren (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual void copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoSFName name
SoSFFloat size

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoFont ()
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const
virtual SoNotRec createNotRec (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoFont class is an appearance node for setting fonts. Successive text rendering nodes (like SoText2, SoText3, SoAsciiText, etc) will use the font specified from an SoFont node when visualizing text.

The font name is recognized with the form "family:style". The range of supported font families depends on which fonts are installed on the system. A typical font family might be "Arial" or "Times NewRoman".

Style is either "Bold", "Italic" or "Bold Italic".

Spaces before or after the ":" will be ignored.

If a good match for the chosen font cannot be found, the default font will be loaded instead. The default 2D font is a built-in 8x12 points font. The 3D font is a serif font ala Times New Roman. It is not possible to apply styles to any of the built-in fonts. It is not possible to specify a size for the default 2D font.

One can explicitly select the default font by setting "defaultFont" as the font name, or by just leaving the SoFont::name field alone, as it has that value by default. In that regard, note that SoFont does not inherit / accumulate any parts from earlier SoFont-nodes, even when one or both of its fields are left blank in e.g. an iv-file, like this:

#Inventor V2.1 ascii
Font { name "Helvetica"  size 50 }
Text2 { string "hepp" }
Translation { translation 5 80 0 }
BaseColor { rgb 1 1 0 }
Font { size 30 }
Text2 { string "svupp" }

(The second string in the above example will be rendered with the default built-in font, not in Helvetica.)

The default fonts are always accessible by Coin as they are embedded into the runtime library. If one needs to guarantee that the text will have the same appearance under all circumstances, the default font will be a safe choice. Another solution might be to use the FreeType font engine and explicitly name a font-file. This is described in more detail below.

Here is a simple example on how to print a string using a bold and italic Arial font:

#Inventor V2.1 ascii
Separator {
   Font {
     name "Arial:Bold Italic"
     size 14
   }
   Text2 {
     string ["This is a", "Coin font test"]
     justification CENTER
   }
}

Coin has support for two different font APIs. On non-Windows platforms, the FreeType library together with the optional Fontconfig library is used.

If the Fontconfig library is installed the font file on the system for a given font name will be located through it. For more information on Fontconfig see http://freedesktop.org/software/fontconfig . Additionally Fontconfig allows to match specific fonts through its own pattern matching format (see http://pdx.freedesktop.org/~fontconfig/fontconfig-user.html). Please note that the point size value in the textual representation of the Fontconfig pattern is currently overridden by the size field of the SoFont node and if no size field is specified the default value of the size field is in effect. In case you intend to use your application on systems where the Fontconfig library is expected to be not installed you should not make use of Fontconfig's font pattern syntax. Fontconfig usage can be prevented by setting the "COIN_FORCE_FONTCONFIG_OFF" environment variable to 1.

Here is an example on how to print a string using the Fontconfig pattern matching syntax using a bold & italic font where Times New Roman is the preferred font family.

#Inventor V2.1 ascii
Separator {
   Font {
     name "Times New Roman,Arial,Helvetica:italic:bold"
     size 24
   }
   Text2 {
     string ["This is a", "Coin font test"]
     justification CENTER
   }
}

On Windows the Win32 GDI library is used. FreeType and Fontconfig are dynamically loaded on demand by Coin if font support is requested by a node. When font support is loaded on Windows, FreeType will have precedence over Win32 if located. This can be prevented by setting the "COIN_FORCE_FREETYPE_OFF" environment variable to 1. When using FreeType, you need FreeType version 2.1 or later. On Mac OS X, version 2.1.7 or later is required.

If Coin cannot load the FreeType library, and is not running on Microsoft Windows, only the default fonts will be accessible.

It is possible to specify the TrueType font file directly if FreeType is used as the font engine. This is done by including the ".ttf" in the filename, i.e. "Comic_Sans_MS.ttf". Coin will then search the local path for the running program and then the path specified by the "COIN_FONT_PATH" environment variable. If the program is using FreeType on a Windows platform, the "$WINDIR/Fonts" directory will also be searched.

It is not possible to directly specify a TrueType font file if Windows is handling the fonts. This is due to the way Windows is accessing the fonts through the system registry. All fonts must therefore be properly installed and given a system name. Open the "Control Panel" and double click on the "Fonts" icon for an overview of installed fonts and their names.

Beware that some non-English versions of Windows are using different name for the styles (i.e. "Italique" instead of "Italic"). These names are supported in Coin, but it is recommended for portability purposes to only use the English terms. Please note that there is still a possibility that there are no fonts installed using the terms "Bold" or "Italic" on the Windows platform. To guarantee that a font is accessible you must either use the FreeType library and include a TrueType font in your distribution, or you must avoid using styles and stick to the standard Windows fonts.

If the "COIN_DEBUG_FONTSUPPORT" environment variable is set to 1, an extensive amount of information about loading, initializing and using fonts will be output. Issues like missing fonts and other related problems will then be reported, so we advice you to first try to use that debugging option when something does not work quite as expected.

FILE FORMAT/DEFAULTS:

Font {
    name "defaultFont"
    size 10
}

See also
    SoFontStyle, SoText2, SoText3, SoAsciiText

Constructor & Destructor Documentation

  SoFont::SoFont (void )
Constructor.

  SoFont::~SoFont () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoFont::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoFont::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

Reimplemented in SoFontStyle.

  const SoFieldData ** SoFont::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoFont::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

Reimplemented in SoFontStyle.

  void SoFont::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

Reimplemented in SoFontStyle.

  void SoFont::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoFontStyle.

  void SoFont::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Reimplemented in SoFontStyle.

  void SoFont::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Reimplemented in SoFontStyle.

  void SoFont::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

Reimplemented in SoFontStyle.

  void SoFont::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoFontStyle.

Member Data Documentation

  SoSFName SoFont::name
Name of font.

Which font names are available is rather system dependent, not only on whether or not you are running on a UNIX/Linux system, Microsoft Windows or whatever, but also on which fonts and font types (like TrueType) are installed on a particular user's system.

All font rendering nodes have a built-in fallback font to use, though, so even though Coin cannot find a font on the system of the specified type, the text should be rendered somehow.

In summation, consider this node type and this particular field as a hint to the font rendering engines of Coin, and do not base your models on a particular font being available.

  SoSFFloat SoFont::size
Size of font. Defaults to 10.0.

For 2D rendered bitmap fonts (like for SoText2), this value is the height of a character in screen pixels. For 3D text, this value is the world space coordinates height of a character in the current units setting (see documentation for SoUnits node).

Author

Generated automatically by Doxygen for Coin from the source code.